/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.mangue.client.gui.anciennete;

import java.awt.BorderLayout;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JDialog;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.mangue.client.gui.situation.AffectationOccupationView;
import org.cocktail.mangue.common.utilities.CocktailConstantes;
import org.cocktail.mangue.common.utilities.CocktailIcones;
import org.cocktail.mangue.modele.FicheAnciennete;
import org.cocktail.mangue.modele.FicheSynthese;

import com.webobjects.eointerface.EODisplayGroup;


/**
 *
 * @author  cpinsard
 */
public class FicheSynthesesView extends JDialog {

protected EODisplayGroup eod;
	protected ZEOTable myEOTable;
	protected ZEOTableModel myTableModel;
	protected TableSorter myTableSorter;

	private static final long serialVersionUID = -6195866169790317637L;

	/** Creates new form TemplateJDialog */
    public FicheSynthesesView(java.awt.Frame parent, boolean modal, EODisplayGroup eod) {
        super(parent, modal);
    	
    	this.eod = eod;
    	
        initComponents();
        initGui();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewSyntheses = new javax.swing.JPanel();
        viewTable = new javax.swing.JPanel();
        btnCalculer = new javax.swing.JButton();
        btnImprimer = new javax.swing.JButton();
        popupTypeSynthese = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("BUDGET");

        viewTable.setLayout(new java.awt.BorderLayout());

        btnCalculer.setText("Calculer");

        btnImprimer.setText("Imprimer");

        popupTypeSynthese.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        org.jdesktop.layout.GroupLayout viewSynthesesLayout = new org.jdesktop.layout.GroupLayout(viewSyntheses);
        viewSyntheses.setLayout(viewSynthesesLayout);
        viewSynthesesLayout.setHorizontalGroup(
            viewSynthesesLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(viewSynthesesLayout.createSequentialGroup()
                .addContainerGap()
                .add(viewSynthesesLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(viewSynthesesLayout.createSequentialGroup()
                        .add(132, 132, 132)
                        .add(btnCalculer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 127, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnImprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 127, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(popupTypeSynthese, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 153, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(viewTable, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 568, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(152, Short.MAX_VALUE))
        );
        viewSynthesesLayout.setVerticalGroup(
            viewSynthesesLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(viewSynthesesLayout.createSequentialGroup()
                .addContainerGap()
                .add(popupTypeSynthese, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewTable, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 454, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewSynthesesLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnCalculer)
                    .add(btnImprimer))
                .addContainerGap(119, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(viewSyntheses, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(22, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(19, 19, 19)
                .add(viewSyntheses, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-778)/2, (screenSize.height-689)/2, 778, 689);
    }// </editor-fold>//GEN-END:initComponents

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                FicheSynthesesView dialog = new FicheSynthesesView(new javax.swing.JFrame(), true, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
					public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCalculer;
    private javax.swing.JButton btnImprimer;
    private javax.swing.JComboBox popupTypeSynthese;
    private javax.swing.JPanel viewSyntheses;
    private javax.swing.JPanel viewTable;
    // End of variables declaration//GEN-END:variables

   
    private void initGui() {
    	
    	btnCalculer.setIcon(CocktailIcones.ICON_RENOUVELER);   	
    	btnImprimer.setIcon(CocktailIcones.ICON_PRINTER_16);
    	
    	popupTypeSynthese.removeAllItems();
    	popupTypeSynthese.addItem("Fiche ANCIENNETE");
    	popupTypeSynthese.addItem("Fiche CARRIERE");
    	popupTypeSynthese.addItem("Fiche CIR");
    	

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

		ZEOTableModelColumn col = new ZEOTableModelColumn(eod, FicheAnciennete.LL_POPULATION_KEY , "Population", 100);
		col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
		col = new ZEOTableModelColumn(eod, FicheSynthese.STATUT_KEY, "Statut", 60);
		col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, FicheSynthese.DATE_DEBUT_KEY, "Début", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay(new SimpleDateFormat("dd/MM/yyyy"));
		col.setColumnClass(Date.class);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, FicheSynthese.DATE_FIN_KEY, "Fin", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay(new SimpleDateFormat("dd/MM/yyyy"));
		col.setColumnClass(Date.class);
    	myCols.add(col);

//		col = new ZEOTableModelColumn(eod, FicheSynthese.CORPS_KEY, "Corps", 75);
//		col.setAlignment(SwingConstants.LEFT);
//    	myCols.add(col);
//		col = new ZEOTableModelColumn(eod, FicheSynthese.GRADE_KEY, "Grade", 75);
//		col.setAlignment(SwingConstants.LEFT);
//    	myCols.add(col);

    	col = new ZEOTableModelColumn(eod, FicheSynthese.QUOTITE_KEY, "Quotite", 75);
		col.setAlignment(SwingConstants.RIGHT);
    	myCols.add(col);

		col = new ZEOTableModelColumn(eod, FicheSynthese.SV_ANNEES_KEY, "Ans", 35);
		col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
		col = new ZEOTableModelColumn(eod, FicheSynthese.SV_MOIS_KEY, "Mois", 35);
		col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
		col = new ZEOTableModelColumn(eod, FicheSynthese.SV_JOURS_KEY, "Jours", 35);
		col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
		col = new ZEOTableModelColumn(eod, FicheSynthese.TEM_PC_ACQUITEES_KEY, "PC", 35);
		col.setAlignment(SwingConstants.CENTER);
    	myCols.add(col);

    	myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		

		myEOTable.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTable.setLayout(new BorderLayout());
		viewTable.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTable.removeAll();
		viewTable.add(new JScrollPane(myEOTable), BorderLayout.CENTER);

    }

	public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}

	public javax.swing.JButton getBtnCalculer() {
		return btnCalculer;
	}

	public void setBtnCalculer(javax.swing.JButton btnCalculer) {
		this.btnCalculer = btnCalculer;
	}

	public javax.swing.JButton getBtnImprimer() {
		return btnImprimer;
	}

	public void setBtnImprimer(javax.swing.JButton btnImprimer) {
		this.btnImprimer = btnImprimer;
	}

	public javax.swing.JComboBox getPopupTypeSynthese() {
		return popupTypeSynthese;
	}

	public void setPopupTypeSynthese(javax.swing.JComboBox popupTypeSynthese) {
		this.popupTypeSynthese = popupTypeSynthese;
	}

	public javax.swing.JPanel getViewSyntheses() {
		return viewSyntheses;
	}

	public void setViewSyntheses(javax.swing.JPanel viewSyntheses) {
		this.viewSyntheses = viewSyntheses;
	}

    
}
